uniform float colorRatio;
uniform float styleRatio;
uniform sampler2D resultImage;

mat3 rgb2yuv = mat3(0.2992, 0.587, 0.114, -0.147, -0.289, 0.436, 0.615, -0.515, -0.1);
mat3 yuv2rgb = mat3(1.0, 0.0, 1.140, 1.0, -0.395, -0.581, 1.0, 2.032, 0.0);

vec4 kernel(vec2 position) {
    vec3 i = rgb2yuv * texture2D(inputImage, position).rgb;
    vec3 r = rgb2yuv * texture2D(resultImage, position).rgb;
    vec3 o;
    o[0] = styleRatio * r[0] + (1.0 - styleRatio) * i[0];
    o[1] = colorRatio * r[1] + (1.0 - colorRatio) * i[1];
    o[2] = colorRatio * r[2] + (1.0 - colorRatio) * i[2];
    o = yuv2rgb * o;
    return vec4(o, texture2D(inputImage, position).a);
}
