/*
 * Implements the 'Lighten' blend mode by Mask.
 */

uniform sampler2D blendMask;

vec3 blend(vec3 src, vec3 dst) {
    float coff = texture2D(blendMask, textureCoordinate.xy / textureCoordinate.z).x;
    return coff * max(src, dst) + (1.0 - coff) * src;
}