/*
 * Implements the 'Overlay' blend mode.
 */

uniform sampler2D blendMask;

vec3 blend(vec3 src, vec3 dst) {
    float coff = texture2D(blendMask, textureCoordinate.xy / textureCoordinate.z).x;
    if ((dst.r + dst.g + dst.b) / 3.0 > 0.5) {
        return coff * (2.0 * dst * src) + (1.0 - coff) * src;
    } else {
        return coff * (1.0 - 2.0 * (1.0 - dst) * (1.0 - src)) + (1.0 - coff) * src;
    }
}
