/*
 * Draws background mask color to the canvas.
 */
#extension GL_EXT_shader_framebuffer_fetch : require

precision mediump float;

uniform vec4 color;
uniform sampler2D mask;

varying vec3 textureCoordinate;

void main() {
    float alpha = texture2D(mask, vec2(textureCoordinate.x, 1.0 - textureCoordinate.y) / textureCoordinate.z).r;
    gl_FragColor = vec4(color.rgb, color.a * (1.0 - alpha));
}