/*
 * Samples the board texture and then blends it with the current framebuffer color. The result is
 * then subject to standard alpha blending.
 */

uniform sampler2D boardTexture;
uniform float alpha;

varying vec3 textureCoordinate;

// The implementation of the blend() function is provided by a separate source file
vec3 blend(vec3 src, vec3 dst);

void main() {
    vec4 boardSample = texture2D(boardTexture, textureCoordinate.xy / textureCoordinate.z);

    vec3 blendResult = blend(boardSample.rgb, gl_LastFragData[0].rgb);

    gl_FragColor = vec4(blendResult, boardSample.a * alpha);
}
