/*
 * Writes the given board index (encoded as a color) to all pixels where the board alpha is at least
 * a half.
 */

uniform sampler2D boardTexture;
uniform int activationMode;
uniform vec3 boardIndex;

varying vec3 textureCoordinate;

void main() {
    vec4 boardSample = texture2D(boardTexture, textureCoordinate.xy / textureCoordinate.z);

    // Discard samples with an alpha less than half
    if (activationMode == 0 && boardSample.a < 0.1) {
        discard;
    }

    gl_FragColor = vec4(boardIndex, 1.0);
}
