/*
 * Renders a simple 4x4 gaussian blur of the passed board texture.
 */

uniform sampler2D boardTexture;
uniform vec3 offsetsAndWeights[16];
uniform float shadowAlpha;
uniform float alpha;

varying vec2 textureCoordinate;

vec4 texture2DBounds(sampler2D tex, vec2 point)
{
    if (point.x < 0.0 || point.x > 1.0 || point.y < 0.0 || point.y > 1.0) {
        return vec4(0.0, 0.0, 0.0, 0.0);
    }
    return texture2D(tex, point);
}

void main() {
    vec2 tc = textureCoordinate;

    // This loop is manually unrolled because doing so improved performance
    float shadow = texture2DBounds(boardTexture, tc + offsetsAndWeights[ 0].xy).a * offsetsAndWeights[ 0].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 1].xy).a * offsetsAndWeights[ 1].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 2].xy).a * offsetsAndWeights[ 2].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 3].xy).a * offsetsAndWeights[ 3].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 4].xy).a * offsetsAndWeights[ 4].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 5].xy).a * offsetsAndWeights[ 5].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 6].xy).a * offsetsAndWeights[ 6].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 7].xy).a * offsetsAndWeights[ 7].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 8].xy).a * offsetsAndWeights[ 8].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[ 9].xy).a * offsetsAndWeights[ 9].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[10].xy).a * offsetsAndWeights[10].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[11].xy).a * offsetsAndWeights[11].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[12].xy).a * offsetsAndWeights[12].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[13].xy).a * offsetsAndWeights[13].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[14].xy).a * offsetsAndWeights[14].z +
                   texture2DBounds(boardTexture, tc + offsetsAndWeights[15].xy).a * offsetsAndWeights[15].z;

    gl_FragColor = vec4(0.0, 0.0, 0.0, shadow * shadowAlpha * alpha);
}
