uniform float decontaminated;
uniform sampler2D origin_img;
uniform sampler2D alpha_mask;
uniform sampler2D fg_map;

vec4 halfTransparent(vec4 img) {
    return vec4(img.rgb, img.w + (1.0 - img.w) / 2.0);
}

vec4 kernel(vec2 position) {
    float a = texture2D(alpha_mask, position).r;
    vec4 result = vec4(texture2D(fg_map, position).rgb * a + texture2D(origin_img, position).rgb * (1.0 - a), a);
    return decontaminated * halfTransparent(result) + (1.0 - decontaminated) * halfTransparent(texture2D(inputImage, position));
}
