uniform float step;

uniform int radius;

uniform float coff[100];

vec4 kernel(vec2 position) {
    float accum = 0.0;
    vec4 orig_color = texture2D(inputImage, position);
    
    accum += orig_color.w * coff[0];
    for (int i = 1; i <= radius; ++i) {
        accum += texture2D(inputImage, vec2(position.x + step * float(i), position.y) ).w * coff[i];
        accum += texture2D(inputImage, vec2(position.x - step * float(i), position.y) ).w * coff[i];
    }
    
    orig_color.w = accum;
    return orig_color;
}