uniform float step;
uniform highp float coff_step;
uniform int radius;
uniform sampler2D mask;
uniform sampler2D coff;

vec4 kernel(vec2 position) {
    float line = float(radius) * coff_step;
    vec3 accum = vec3(0.0, 0.0, 0.0);
    
    accum += texture2D(inputImage, position).xyz * texture2D(coff, vec2(0.0, line)).r;
    float sum = texture2D(coff, vec2(0.0, line)).r;
    
    for (int i = 1; i <= radius; ++i) {
        float key1 = texture2D(mask, vec2(position.x + step * float(i), 1.0 - position.y)).r;
        float key2 = texture2D(mask, vec2(position.x - step * float(i), 1.0 - position.y)).r;
        float curr_coff = texture2D(coff, vec2(coff_step * float(i), line)).r;
        accum += texture2D(inputImage, vec2(position.x + step * float(i), position.y) ).xyz * key1 * curr_coff
               + texture2D(inputImage, vec2(position.x - step * float(i), position.y) ).xyz * key2 * curr_coff;
        sum += key1 * curr_coff + key2 * curr_coff;
    }
    
    return vec4(accum / sum, texture2D(inputImage, position).w);
}