uniform float step;

uniform int radius;

uniform float coff[100];

vec4 kernel(vec2 position) {
    vec4 accum = vec4(0.0, 0.0, 0.0, 0.0);
    accum += texture2D(inputImage, position) * coff[0];
    for (int i = 1; i <= radius; ++i) {
        accum += texture2D(inputImage, vec2(position.x + step * float(i), position.y) ) * coff[i];
        accum += texture2D(inputImage, vec2(position.x - step * float(i), position.y) ) * coff[i];
    }
    return accum;
}