uniform float input_step;
uniform highp float coff_step;
uniform int radius;
uniform sampler2D mask;
uniform sampler2D coff;

vec4 kernel(vec2 position) {
    int radius_cur = int(float(radius) * texture2D(mask, vec2(position.x, 1.0 - position.y)).r);
    float line = float(radius_cur) * coff_step;
    
    vec3 accum = vec3(0.0, 0.0, 0.0);
    accum += texture2D(inputImage, position).xyz * texture2D(coff, vec2(0.0, line)).r;
    float sum = texture2D(coff, vec2(0.0, line)).r;
    for (int i = 1; i <= radius_cur; ++i) {
        float key1 = step(0.00001, texture2D(mask, vec2(position.x + input_step * float(i), 1.0 - position.y)).r);
        float key2 = step(0.00001, texture2D(mask, vec2(position.x - input_step * float(i), 1.0 - position.y)).r);
        float curr_coff = texture2D(coff, vec2(coff_step * float(i), line)).r;
        accum += (texture2D(inputImage, vec2(position.x + input_step * float(i), position.y) ).xyz * key1
                + texture2D(inputImage, vec2(position.x - input_step * float(i), position.y) ).xyz * key2)
                * curr_coff;
        sum += key1 * curr_coff + key2 * curr_coff;
    }                
    return vec4(accum / sum, texture2D(inputImage, position).w);
}