uniform float step;
uniform highp float coff_step;
uniform int radius;
uniform highp float start;
uniform highp float end;
uniform sampler2D coff;

vec4 kernel(vec2 position) {
    int radius_cur;
    if (end == start) {
        radius_cur = 0;
    } else {
        if (start > end) {
            radius_cur = int(float(radius) * (1.0 - clamp(((1.0 - position.x) - end) / (start - end) ,0.0 , 1.0) ));
        } else {
            radius_cur = int(float(radius) * (1.0 - clamp(((position.x) - start) / (end - start) ,0.0 , 1.0) ));
        }
    }
    float line = float(radius_cur) * coff_step;
    
    vec3 accum = vec3(0.0, 0.0, 0.0);
    accum += texture2D(inputImage, position).xyz * texture2D(coff, vec2(0.0, line)).r;
    float sum = texture2D(coff, vec2(0.0, line)).r;
    for (int i = 1; i <= radius_cur; ++i) {
        accum += (texture2D(inputImage, vec2(position.x + step * float(i), position.y) ).xyz
                + texture2D(inputImage, vec2(position.x - step * float(i), position.y) ).xyz)
                * texture2D(coff, vec2(coff_step * float(i), line)).r;
        sum += 2.0 * texture2D(coff, vec2(coff_step * float(i), line)).r;
    }                
    return vec4(accum / sum, texture2D(inputImage, position).w);
}