uniform float step;

uniform int radius;

uniform float coff[100];

uniform sampler2D mask;

vec4 kernel(vec2 position) {
    vec4 orig_color = texture2D(inputImage, position);
    if (texture2D(mask, position).w == 1.0) {
        float accum = 0.0;
        orig_color = texture2D(inputImage, position);
        
        accum += orig_color.w * coff[0];
        for (int i = 1; i <= radius; ++i) {
            accum += (texture2D(inputImage, vec2(position.x + step * float(i), position.y) ).w + texture2D(inputImage, vec2(position.x - step * float(i), position.y) ).w) * coff[i];
        }
        
        orig_color.w = accum;
    } else {
        orig_color = texture2D(inputImage, position);
    }
    return orig_color;
}