uniform float step;

uniform int radius;

uniform sampler2D mask;

vec4 kernel(vec2 position) {
    vec4 orig_color = texture2D(inputImage, position);
    if (texture2D(mask, position).w == 1.0) {
        float min_val = orig_color.w;
        float tmp = 0.0;
        
        for (int i = 1; i <= radius; ++i) {
            tmp = texture2D(inputImage, vec2(position.x + step * float(i), position.y) ).w;
            if (tmp < min_val) {                                                                            
                min_val = tmp;                                                                                
            }                                                                                                                  
                                                                                                                                
            tmp = texture2D(inputImage, vec2(position.x - step * float(i), position.y) ).w;
            if (tmp < min_val) {                       
                min_val = tmp;
            }
        }                                                             
        
        orig_color.w = min_val;
    }
    return orig_color;
}