uniform float step;

uniform int radius;

vec4 kernel(vec2 position) {
    float accum = 0.0;
    
    accum += texture2D(inputImage, position).w;
    for (int i = 1; i <= radius; ++i) {
        accum += texture2D(inputImage, vec2(position.x + step * float(i), position.y) ).w + texture2D(inputImage, vec2(position.x - step * float(i), position.y) ).w;
    }
    
    return vec4(0.0, 0.0, 0.0, accum / float(2 * radius + 1));
}