uniform float step;

uniform int radius;

vec4 kernel(vec2 position) {
    float accum = 0.0;
    
    accum += texture2D(inputImage, position).w;
    for (int i = 1; i <= radius; ++i) {
        accum += texture2D(inputImage, vec2(position.x, position.y + step * float(i)) ).w + texture2D(inputImage, vec2(position.x, position.y - step * float(i)) ).w;
    }
    
    vec4 res;
    if (accum == 0.0 || accum == float(2 * radius + 1)) {
        res = vec4(0.0, 0.0, 0.0, 0.0);
    } else {
        res = vec4(0.0, 0.0, 0.0, 1.0);
    }
    
    return res;
}