/*
 * This used for custom case line rendering. (with blending mode equation set to GL_MIN).
 */

precision mediump float;

uniform float strength;
uniform float color;

varying float distanceToEdge;

void main() {
    float k = (log2((distanceToEdge * 4.0) + 4.0) - 2.0) * 1.2;
    float coff = min(1.0, strength) * (max(1.0, strength) - clamp(k, 0.0, 1.0));
    gl_FragColor = color == 0.0 ? vec4(coff, coff, coff, 1.0) : vec4(color - coff, color - coff, color - coff, 1.0);
}                                                                                      