/*
 * Processes line vertices. The `z` component is the normalized distance to the edge of the line.
 */

attribute vec3 positionAttribute;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;

varying float distanceToEdge;

void main() {
    distanceToEdge = positionAttribute.z;

    gl_Position = projectionMatrix * modelMatrix * vec4(positionAttribute.xy, 0.0, 1.0);
}