uniform vec2 shadowOffset;
uniform vec4 color;

vec4 kernel(vec2 position) {
    float alpha = texture2D(inputImage, position).r;
    float shadowAlpha = texture2D(inputImage, vec2(position.x - shadowOffset.x, position.y + shadowOffset.y)).r;
    if (alpha * shadowAlpha != 0.0) {
        return vec4(color.rgb * alpha, 1.0);
    }
    if (alpha != 0.0) {
        return vec4(color.rgb, alpha);
    }
    return vec4(0.0, 0.0, 0.0, shadowAlpha * 0.8);
}
